//+------------------------------------------------------------------+
//|                                                          Nov.mq4 |
//|                                                       Dm_35 2008 |
//|                                          http://www.fxexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"

#property indicator_chart_window

//*************
extern int       StartHour    = 0;
extern int       StartMinute  = 0;
extern int       CountDays    = 10;

extern color     Col          = Aqua;
extern int       pstyle       = 0;
extern int       pwidth       = 2;
extern color     Col2         = Red;
extern int       pstyle2      = 0;
extern int       pwidth2      = 2;

double range[];
double ny_close[];

datetime time1;
datetime time2;
datetime ny_time[];

int shift, num;
int ny_shift[];
datetime prevDay=0;
bool fTime;
int i;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);

   SetIndexBuffer(0,range);
   SetIndexBuffer(1,ny_close);	
   fTime = true;	   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
   ObjDel();
   Comment("");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   double P,R1;
   int length1;
   int StartMinutesIntoDay=((StartHour*60)+StartMinute)*60;
        
      datetime cDay = iTime(NULL,PERIOD_D1,0) + StartMinutesIntoDay;
        
   if (cDay != prevDay || fTime)  
   {
   ObjDel();
   ArrayResize(ny_time,CountDays+1);
   ArrayResize(ny_shift,CountDays+1);
   

           
      for (shift=0;shift<=CountDays;shift++)
      {
      ny_time[shift]  = iTime(NULL,PERIOD_D1,shift) + StartMinutesIntoDay;
      ny_shift[shift] = iBarShift(NULL,0,ny_time[shift]);
      ny_close[shift] = iOpen(NULL,0,ny_shift[shift]);        
      }
  
      for (shift=0;shift<=CountDays-1;shift++)
      {
 
      P  = ny_close[shift];
      R1=ny_close[shift+1];

         time1 = ny_time[shift];    
         
         if (shift==0) 
         time2 = ny_time[shift] + 24*3600 ;
         else
         time2 = ny_time[shift-1];

      PlotLine("PPP["+shift+"]",P,P,time1,time2,Col,pwidth,pstyle);
      PlotLine("RP1["+shift+"]",P,R1,time2,time1,Col2,pwidth2,pstyle2);
      }
   fTime = false;
   prevDay = cDay;
   }        
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
void ObjDel()
{
   if (ObjectsTotal() > 0)
   for (num=0;num<=CountDays;num++)
   {
   ObjectDelete("PPP["+num+"]");
   ObjectDelete("RP1["+num+"]");

   }
}
// ----
void PlotLine(string name,double value,double value1,datetime time3,datetime time4,double line_color,double width,double style)
{
   bool res = ObjectCreate(name,OBJ_TREND,0,time3,value,time4,value1);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
}

